#!/usr/bin/python


import re,string

aaa = re.compile("//;; *(\w+) +(\w+) +(\w+) +(\w+) +")

_int = re.compile("\d+")

_float = re.compile("[+-]?\d+\.?\d*")


_3n = re.compile("< *(\w*\.?\w*) *, *(\w*\.?\w*) *, *(\w*\.?\w*) *>")
_3n1 = re.compile("< *\w*\.?\w* *, *\w*\.?\w* *, *\w*\.?\w* *>")

comment = re.compile("/[*][^*]*[*]/",re.DOTALL)
comment1 = re.compile("//.*")
Listekw1 = ['camera','global_settings','light_source','sky_sphere']
kw = re.compile(string.join(Listekw1,'|'))
kw1 = re.compile('#include .*|#declare .*')


def findall(r,s):
    ret=[]
    resu = r.search(s)
    while resu :
        (t1,t2) = resu.span()
        ret.append((t1,t2))
        resu = r.search('x'*t2+s[t2:])
    return ret

def traduit(InitString,Id,Val):
    #on recherche toutes les sous chaines susceptibles de remplacement
    rech1 = re.compile("< *"+Id+" *, *\w+\.?\w* *, *\w+\.?\w* *>")
    rech2 = re.compile("< *\w+\.?\w* *, *"+Id+" *, *\w+\.?\w* *>")
    rech3 = re.compile("< *\w+\.?\w* *, *, *\w+\.?\w* *, *"+Id+" *>")
    ListOccurences1 = re.findall(rech1,InitString)
    ListOccurences2 = re.findall(rech2,InitString)
    ListOccurences3 = re.findall(rech3,InitString)
    ListOccurences = ListOccurences1 + ListOccurences2 + ListOccurences3
    print ListOccurences1,ListOccurences2,ListOccurences3
    ListPositions = []
    for occ in ListOccurences:
        print occ
        matchobj = re.search(occ,InitString)
        print matchobj
        if matchobj : ListPositions.append((matchobj.start(), matchobj.end()))
    #print ListPositions
    npos = len(ListPositions)
    s = ""
    start = 0
    if not ListPositions : return InitString
    print ListPositions
    for pos in ListPositions :
        s = s + InitString[start:pos[0]]
        start = pos[1]
        #inserer la traduction de
        BlocInitial = InitString[pos[0]:pos[1]]
        BlocFinal=re.sub(Id,Val,BlocInitial)
        #print BlocFinal
        s = s + BlocFinal
    s = s + InitString[ListPositions[npos-1][1]:]
    return s




def ChercheInit(str):
    """recherche une chaine du type //;; ident nb1 nb2 nb3"""
    pattern = '//;; +\w+ +\d+.?\d* +\d+.?\d* +\d+.?\d*'
    x = re.search(pattern,str)
    if not x : return None
    ch = str[x.start():x.end()]
    l = ch.split()
    print "ChercheInit",l
    return (l[1],float(l[2]),float(l[3]),float(l[4]))

def ListFiles(initfile):
    #return [initfile]
    r = ChercheInit(initfile)
    #il faut chercher toutes les occurences et boucler dessus
    if not r : return [initfile]
    else :
        ret = []
        (ident,start,end,nsteps) = r 
        delta = (end - start)/nsteps
        for i in range(nsteps+1):
            vv = "%f"%(start+i*delta)
            #print initfile,ident,vv
            newfile = traduit(initfile,ident,vv)
            #print newfile
            ret.append(newfile)
        return ret
    return None
        

if __name__ == '__main__':
    s = open('test1.pov').read()
    print ListFiles(s)
    

