#!/usr/bin/python

import re

import Tkinter
from Tkinter import *



import myglobal
from myglobal import g as Global

class Control:
    def __init__(self, master,str1,str2,str3):
        self.str1 = str1
        self.str2 = str2
        self.str3 = str3
        self.DicoVariables = {}
        self.DicoScales = {}
        self.tl = Toplevel(master)
        self.Positions = RechercheVecteurs(str2)
        self.Npos = len(self.Positions)
        #print self.Npos
        self.Nlig = self.Npos/3
        for lig in range(self.Nlig):
            posini =  int(self.Positions[lig*3][0])
            message = str2[posini-15:posini-3]
            for j in range(3):
                index = lig*3+j
                pos1 = int(self.Positions[index][0])
                pos2 = int(self.Positions[index][1])
                val = float(str2[pos1:pos2])
                #print val
                            
                self.DicoVariables[index] =  DoubleVar()
                self.DicoVariables[index].set(val)
                print val,pos1,pos2

                
                self.DicoScales[index] = Scale(self.tl,orient=HORIZONTAL,showvalue='true')
                
                if val == 0 :
                    __from = val -1
                    __to = val + 1
                    __reso =  .2
                elif val > 0 :
                    __from = val /2
                    __to = val *2
                    __reso =  val*.015
                elif val < 0 :
                    __from = val  * 2
                    __to = val / 2
                    __reso =  val*.015
                #print __from,__to,__reso,val
                self.DicoScales[index].configure(resolution=__reso)
                self.DicoScales[index].configure(label=message)
                self.DicoScales[index].configure(width='10')
                self.DicoScales[index].configure(variable= self.DicoVariables[index])
                self.DicoScales[index].configure(to=__to)
                self.DicoScales[index].configure(from_=__from)
                self.DicoScales[index].set(val)
                self.DicoScales[index].grid(row = lig, column=j)
        
        

        self.bvisu =  Button(self.tl,text="VISU",command = self.buttonvisu).grid(row = self.Nlig,column = 0)
        self.bok =  Button(self.tl,text="OK",command = self.buttonok).grid(row = self.Nlig,column = 1)
        self.bcancel =  Button(self.tl,text="Cancel",command = self.buttoncancel).grid(row = self.Nlig,column = 2)



        
    def buttonvisu(self):
        #reconstruction du fichier avec les nouvelles valeurs

        #le debut de str2, avant le premier float detecte
        s = self.str2[0:self.Positions[0][0]]

        #pour chaque triplet, on range 3 floats + la suite du fichier jusqu'au vecteur suivant
        for li in range(self.Nlig - 1) :
            s = s + "%f"%self.DicoVariables[li*3].get()+','+ "%f"%self.DicoVariables[li*3+1].get()+','+"%f"%self.DicoVariables[li*3+2].get()
            s = s + self.str2[self.Positions[li*3+2][1]:self.Positions[(li+1)*3][0]]

        # traitement du dernier vecteur. La suite du fichier va jusqu'a la fin de str2
        li = self.Nlig - 1
        s = s + "%f"%self.DicoVariables[li*3].get()+','+ "%f"%self.DicoVariables[li*3+1].get()+','+"%f"%self.DicoVariables[li*3+2].get()
        s = s + self.str2[self.Positions[self.Npos-1][1]:]
        #On rajoute les zones non selectionnees
        s = self.str1+s+self.str3
        #on range s dans l'editeur actif
        import Pmw
        num =Global.Interface.notebook.index(Pmw.SELECT)
        editor = Global.Interface.ListEditors[num]
        editor.delete(1.0,END)
        editor.insert(1.0,s)
        #on effectue un rendu
        import povedit
        povedit.Visu()
        
        
        
    def buttonok(self):
        for lig in range(self.Nlig):
            for j in range(3):
                index = lig*3+j
                val = self.DicoScales[index].get()
                
                if val == 0 :
                    __from = val -1
                    __to = val + 1
                    __reso =  .2
                elif val > 0 :
                    __from = val /2
                    __to = val *2
                    __reso =  val*.015
                elif val < 0 :
                    __from = val  * 2
                    __to = val / 2
                    __reso =  val*.015
                self.DicoScales[index].configure(resolution=__reso)
                self.DicoScales[index].configure(to=__to)
                self.DicoScales[index].configure(from_=__from)
                #self.DicoScales[index].set(val)
        
        
    def buttoncancel(self):
        self.tl.destroy()








def RechercheVecteurs(InitString):
    """ recherche toutes les chaines de la forme <nb1,nb2,nb3>""" 
    ListPos = []
    #on recherche toutes les sous chaines susceptibles de remplacement
    rech = re.compile("< *(-?\d+\.?\d*) *, *(-?\d+\.?\d*) *, *(-?\d+\.?\d*) *>")
    matchobject = rech.search(InitString)
    if not matchobject : return []
    while matchobject :
        for i in range(3):
            ListPos.append((matchobject.start(i+1),matchobject.end(i+1)))
        st = matchobject.end()
        matchobject = rech.search(InitString,st)
    return ListPos



if __name__ == '__main__':
    s = open('test1.pov').read()
    x = RechercheVecteurs("mlkmlkmlk",s,"mmmmmmmmmmmmmm")
    print x
    x=Control(None)
    x.tl.mainloop()
